var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { userService } from 'lsi-spfx-services';
import * as React from 'react';
import styles from './OverviewUserSection.module.scss';
export var OverviewUserSection = function (_a) {
    var label = _a.label, userLogins = _a.userLogins, hideCount = _a.hideCount, onSelectUser = _a.onSelectUser, reverseDisplay = _a.reverseDisplay;
    var _b = React.useState([]), users = _b[0], setUsers = _b[1];
    var load = function () { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, userService.getCompleteUsers(userLogins)];
                case 1:
                    res = _a.sent();
                    if (reverseDisplay)
                        res.reverse();
                    setUsers(res);
                    return [2 /*return*/];
            }
        });
    }); };
    React.useEffect(function () {
        load();
    }, [userLogins]);
    if (!userLogins.length)
        return null;
    var count = hideCount ? null : React.createElement("span", null,
        "(",
        userLogins.length,
        ")");
    return (React.createElement("div", { className: styles.root },
        React.createElement("h4", { className: styles.title },
            label,
            " ",
            count),
        React.createElement("div", { className: styles.personasList, role: "list" }, users.map(function (user) { return React.createElement(OverviewItem, { completeUser: user, onSelectUser: onSelectUser }); }))));
};
export var OverviewItem = function (_a) {
    var completeUser = _a.completeUser, onSelectUser = _a.onSelectUser;
    if (!completeUser)
        return null;
    var user = completeUser.user, profile = completeUser.profile;
    if (!user)
        user = {};
    if (!profile)
        profile = {};
    var imgSrc = "/_layouts/15/userphoto.aspx?size=M&accountname=" + profile.Email;
    return (React.createElement("div", { role: "listitem", className: styles.persona },
        React.createElement("button", { type: "button", className: styles.verticalPersona, role: "button", title: "Select to open profile", onClick: function () { return onSelectUser(profile.AccountName); } },
            React.createElement("div", { className: styles.container1 },
                React.createElement("div", { className: styles.personaCoinContainer },
                    React.createElement("div", { className: styles.imageContainer },
                        React.createElement("img", { key: profile.AccountName, src: imgSrc, alt: user.Title, className: styles.image }))),
                React.createElement("span", { className: styles.name }, profile.DisplayName),
                React.createElement("span", { className: styles.jobTitle }, profile.Title)))));
};
//# sourceMappingURL=OverviewUserSection.js.map